#include <iostream>
#include <cmath>
#include <array>
#include <sstream>
#include "global.h"

std::array<std::array<double, max_denominator>, max_numerator> ucb_bias;

void printPosition(int pos) {
    int add = (pos % kexpanded_board_size > 9 ? 1 : 0);
    std::cerr << (char)('A' + ((pos % kexpanded_board_size) -2) + add)
              << kboard_size - (pos / kexpanded_board_size - 2)
              << std::endl;
}



void doCalucUCBBias() {
    for (int i = 1; i < max_denominator; ++i) {
        for (int j = 1; j < max_numerator; ++j) {
            ucb_bias[j][i] = sqrt(log((double)j) / (double)i);
        }
    }
}

std::string getCharacterPosition(int pos) {
    if (pos == 0) {
        return "Pass";
    }
    if (pos == -1) {
        return "Root";
    }
    std::stringstream ss;
    std::string move;
    int add = (pos % kexpanded_board_size > 9 ? 1 : 0);
    ss << (char)('A' + ((pos % kexpanded_board_size) -2) + add)
       << kboard_size - (pos / kexpanded_board_size - 2);
    ss >> move;

    return move;
}
