#ifndef PLAYOUT_H
#define PLAYOUT_H


#include <random>
#include <memory>
#include <iostream>
#include <string>
#include <atomic>
#include "go_board.h"
#include "global.h"
#include "make_pattern.h"

class PlayOut
{
public:
    PlayOut();
    int doOnePlayOut(int color);
    int doRandomSearch(int color);
    void printPlayOutGoBoard() { playout_go_board_.printGoBoard(); }
    GoBoard playout_go_board_;

    double operator() (const GoBoard &go_board, int color);
private:
    std::shared_ptr<std::mt19937> engine_;
    std::shared_ptr<std::uniform_int_distribution<int> > distribution_;

    enum {
        Black = 0,
        White,
        Empty,
        Wall,
    };

    int getEast(int pos) { return pos + 1; }
    int getWest(int pos) { return pos - 1; }
    int getNorth(int pos) { return pos - kexpanded_board_size; }
    int getSouth(int pos) { return pos + kexpanded_board_size; }
};

#endif // PLAYOUT_H
