#ifndef NODE_H
#define NODE_H

#include <cmath>

class UCBNode
{
public:
    UCBNode();
    long long int win_count_;
    long long int lose_count_;
    long long int trial_count_;
    long long int parent_index_;
    long long int child_index_;
    long long int root_pos_;
    int pos_;
    int color_;
    long long int depth_;
    int score_;
    bool is_legal_move_;
    double ucb_value_;

    double getUCBValue(int total_trial_count) {
        return trial_count_ ? (ucb_value_ = (double) win_count_ / (double) trial_count_ +  sqrt(2 * log(total_trial_count) / trial_count_)) : -1.0;
    }

    static bool descendingOrder(const UCBNode &left, const UCBNode &right) {
        return left.ucb_value_ > right.ucb_value_;
    }

private:

};

#endif // NODE_H
